=== debian/changelog ===
rnp (0.18.0-4) unstable; urgency=medium

  * clean up patches
  * Test suite: clean up interactions with gpg
  * tests: interop tests shouldn't fail when gpg is gpg-sq (Closes: ##1070866)

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Fri, 17 Oct 2025 18:43:00 -0400

rnp (0.18.0-3) unstable; urgency=medium

  * Improve tests for 64-bit time_t on 32-bit platforms

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Fri, 10 Oct 2025 12:46:52 -0400

rnp (0.18.0-2) unstable; urgency=medium

  * Fix assertion breakage on 32bit arches (Closes: #1116189)
  * Clean up RFC9580 error return

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Thu, 09 Oct 2025 17:45:47 -0400

rnp (0.18.0-1) unstable; urgency=medium

  * new upstream release
  * refresh patches, drop those already upstream
  * move to botan 3 (Closes: #1108993)
  * enable OpenPGP v6 (RFC 9580)
  * Avoid test breakage while logging reproducible paths
  * Update symbols
  * Standards-Version: bump to 4.7.2 (no changes needed)
  * Drop "Rules-Requires-Root: no" (now the default)
  * d/copyright: clean up references to removed files.

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Tue, 23 Sep 2025 15:57:13 -0400
