=== debian/control ===
Source: rnp
Section: utils
Priority: optional
Maintainer: Daniel Kahn Gillmor <dkg@fifthhorseman.net>
Build-Depends:
 asciidoctor <!nodoc>,
 cmake (>= 3.14),
 debhelper-compat (= 13),
 gnupg <!nocheck>,
 googletest <!nocheck>,
 libbotan-3-dev,
 libbz2-dev,
 libjson-c-dev (>= 0.11),
 libsexpp-dev,
 pkgconf,
 python3 <!nocheck>,
 zlib1g-dev,
Standards-Version: 4.7.2
Vcs-Git: https://salsa.debian.org/debian/rnp.git
Vcs-Browser: https://salsa.debian.org/debian/rnp
Homepage: https://www.rnpgp.com/software/rnp/

Package: rnp
Architecture: any
Multi-Arch: foreign
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 librnp0 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: Cross-platform OpenPGP (RFC4880) tools (command-line tool)
 RNP is a set of cross-platform tools implementing OpenPGP (RFC 4880) and
 related standards.
 .
 This package contains the command-line tool, rnp.

Package: librnp0
Architecture: any
Section: libs
Multi-Arch: same
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Cross-platform OpenPGP (RFC4880) tools (library)
 RNP is a set of cross-platform tools implementing OpenPGP (RFC 4880) and
 related standards.
 .
 This package contains the shared library, librnp.

Package: librnp-dev
Section: libdevel
Architecture: any
Replaces: librnp-0-dev (<< 0.15.0)
Breaks: librnp-0-dev (<< 0.15.0)
Depends:
 librnp0 (= ${binary:Version}),
 ${misc:Depends},
Description: Cross-platform OpenPGP (RFC4880) tools (development files)
 RNP is a set of cross-platform tools implementing OpenPGP (RFC 4880) and
 related standards.
 .
 This package contains the development headers and documentation used
 to build other tools against the library.
