=== debian/tests/control ===
Tests: build-and-run-examples
Depends:
 gcc,
 libc6-dev,
 librnp-dev,
 pkg-config,
