=== debian/changelog ===
rnp (0.18.1-1build1) resolute; urgency=medium

  * No-change rebuild for libbotan-3-10.

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Sat, 06 Dec 2025 17:48:47 +0000

rnp (0.18.1-1) unstable; urgency=high

  * new upstream release
    - Fix PKESK CEK generation (Fixes: CVE 2025-13470)

  [ Daniel Kahn Gillmor ]
  * drop variant fix for 32-bit architectures, upstream fixes it differently
  * refresh patches

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Fri, 21 Nov 2025 07:51:25 -0500
